com.ihr.xbrl.om.exLinks

## Class LabelLinkbase

- java.lang.Object
- - com.ihr.xbrl.om.XMLFragment
  - - com.ihr.xbrl.om.exLinks.XLinkElement
    - - com.ihr.xbrl.om.exLinks.XBRLExtendedLink
      - - com.ihr.xbrl.om.exLinks.LabelLinkbase

- All Implemented Interfaces:
    HasAdditionalEqualityForReassignation, XBRLAllowsDocumentation, XBRLRelationshipPoint, Thinable, XBRLDTSDocument, XBRLValidation, XMLHasParent, java.io.Serializable, java.lang.Cloneable, javax.xml.namespace.NamespaceContext

      public class LabelLinkbase
      extends XBRLExtendedLink
      implements java.io.Serializable

  The Class LabelLinkbase.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.ihr.xbrl.om.XBRLValidation

      `XBRLValidation.Direction`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `commentary_label_role_URI` The Constant commentary_label_role_URI.
    `static java.lang.String` | `concept_label_arcrole_URI` The Constant concept_label_arcrole_URI.
    `static java.lang.String` | `definition_guidance_label_role_URI` The Constant definition_guidance_label_role_URI.
    `static java.lang.String` | `disclosure_label_role_URI` The Constant disclosure_label_role_URI.
    `static java.lang.String` | `documentation_label_role_URI` The Constant documentation_label_role_URI.
    `static java.lang.String` | `example_label_role_URI` The Constant example_label_role_URI.
    `static java.lang.String` | `label_role_URI` The Constant label_role_URI.
    `static javax.xml.namespace.QName` | `lbResource` The Constant lbResource.
    `static javax.xml.namespace.QName` | `lbType` The Constant lbType.
    `static java.lang.String` | `measurement_label_role_URI` The Constant measurement_label_role_URI.
    `static java.lang.String` | `negative_label_role_URI` The Constant negative_label_role_URI.
    `static java.lang.String` | `negative_terse_label_role_URI` The Constant negative_terse_label_role_URI.
    `static java.lang.String` | `negative_verbose_label_role_URI` The Constant negative_verbose_label_role_URI.
    `static java.lang.String` | `period_end_label_role_URI` The Constant period_end_label_role_URI.
    `static java.lang.String` | `period_start_label_role_URI` The Constant period_start_label_role_URI.
    `static java.lang.String` | `positive_label_role_URI` The Constant positive_label_role_URI.
    `static java.lang.String` | `positive_terse_label_role_URI` The Constant positive_terse_label_role_URI.
    `static java.lang.String` | `positive_verbose_label_role_URI` The Constant positive_verbose_label_role_URI.
    `static java.lang.String` | `presentation_label_role_URI` The Constant presentation_label_role_URI.
    `static javax.xml.namespace.QName` | `standard_arc` The Constant standard_arc.
    `static java.lang.String` | `standard_role_ref` The Constant standard_role_ref.
    `static java.lang.String` | `terse_label_role_URI` The Constant terse_label_role_URI.
    `static java.lang.String` | `total_label_role_URI` The Constant total_label_role_URI.
    `static java.lang.String` | `verbose_label_role_URI` The Constant verbose_label_role_URI.
    `static java.lang.String` | `zero_label_role_URI` The Constant zero_label_role_URI.
    `static java.lang.String` | `zero_terse_label_role_URI` The Constant zero_terse_label_role_URI.
    `static java.lang.String` | `zero_verbose_label_role_URI` The Constant zero_verbose_label_role_URI.

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XBRLExtendedLink

      `standard_role_URI`

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `actuate, ACTUATE, ARC, arcrole, ARCROLE, ETITLE, EXTENDED, from, FROM, href, HREF, label, LABEL, LOCATOR, RESOURCE, role, ROLE, show, SHOW, SIMPLE, title, TITLE, to, TO, type, TYPE`

    - ### Fields inherited from class com.ihr.xbrl.om.XMLFragment

      `CONCEPT_LABEL, CONCEPT_QNAME, EASY_TO_READ, ELEMENT_LABEL, EMPTYRELATIONSHIPSITERATORINSTANCE, EMPTYXMLFRAGMENTITERATORINSTANCE, FACT_CONCEPT_DATATYPE, FACT_CONCEPT_LABEL, FACT_QNAME, HIDE_COMMON_ACCURACY, idQName, NO_POSITION, OrderComparator, OrderComparator2, PERIOD_TYPE, PERIOD_VALUE, SHORT_TEXT, SOURCE_DOCUMENT, XPATH, XPOINTER`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LabelLinkbase(XBRLDocument parent, DTSBase base)` Deprecated. use `LabelLinkbase(XBRLDocument, XBRLRoleType)` instead
    `LabelLinkbase(XBRLDocument parent, XBRLRoleType role)` Creates a LabelLinkbase extended link container.
    `LabelLinkbase(XBRLDocument parent, net.sf.saxon.s9api.XdmNode node)` Instantiates a new label linkbase.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getExtendedLinkTypeName()` Returns a localized constant string indicating the extended link type
    `java.util.Iterator<XBRLLabelResource>` | `getLabelsForRole(XBRLRoleType role)` Gets the labels for role.
    `java.util.Collection<java.lang.String>` | `getStandardDefinedRolesOnResources()` Returns a collection of role URIs that the XBRL 2.1 standard defines to be used on resources on this extended link
    `java.util.Collection<javax.xml.namespace.QName>` | `getStandardResourceNodeNames()` Returns a collection of resource node names that are allowed to exist on this extended link.
    `javax.xml.namespace.QName` | `getStaticLinkbaseType()` This function MUST be implemented by classes derived from this class.
    `boolean` | `isStandardExtendedLink()` Returns true if the extended link belongs to the XBRL 2.1 specification.
    `void` | `readResources()` Reads all resources in this linkbase This method uses XPath to identify the resources and try to obtain the resource object from the DTSContainer cache.

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XBRLExtendedLink

      `addDocumentation, addRelationship, addResource, clear, clearCaches, createExtendedLink, createExtendedLink, createExtendedLink, discoverDTS, equals, generateNode, getArcroles, getArcroleType, getArcs, getAttributes, getDocumentation, getDTSBase, getDTSKey, getElements, getFriendlyName, getLinkbaseType, getLocators, getNumberOfResources, getParent, getRelationships, getResources, getRoleType, getValidationReport, hashCode, invalidate, invalidate, isOnValidation, removeDocumentation, removeRelationship, removeResource, setDTSBase, setParent, setRole, setRoleType, validate, wouldBeDuplicateArc`

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `getActuate, getArcrole, getFromTxt, getHRef, getLabel, getRole, getShow, getStaticLabel, getSType, getTitle, getToTxt, isRequiredAttribute, isValidAttribute, setActuate, setArcrole, setFrom, setHRef, setLabel, setShow, setSType, setTitle, setTo`

    - ### Methods inherited from class com.ihr.xbrl.om.XMLFragment

      `addAttribute, addChild, addFromRelationship, addNamespace, addNamespace, addToRelationship, addXMLChild, changeBase, checkBase, clone, clone, delAttribute, delAttribute, equalXdmValues, evaluateBoolean, evaluateList, evaluateNode, evaluateNumber, evaluateString, generateId, generateNodeNamespacesAndAttributes, generateNodeValue, generatePrefix, getAllAttributes, getAttribute, getAttributeBooleanValue, getAttributeQNameValue, getAttributes, getAttributeStringValue, getAttributeValue, getBase, getBase, getBaseURI, getBooleanValue, getChild, getContainer, getContainerDocumentURI, getDeclaredNamespaces, getDocument, getElementsHashCode, getFragment, getFriendlyName, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getGenericLabelText, getId, getLang, getNamespaceURI, getNodeName, getNumberOfAttributes, getNumberOfElements, getNumberOfFromRelationships, getNumberOfToRelationships, getOrGenerateId, getPrefix, getPrefixes, getQNameValue, getRelationshipsBases, getRelationshipsChain, getRelationshipTypes, getStaticContext, getStaticNamespace, getStringValue, getToolTipText, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getValue, getXPathExecutable, getXPathNamespaceContext, getXPathToNode, getXPathToRoot, getXPointerElementScheme, getXPointerElementScheme, getXPointerShorthandScheme, getXPointerToNode, isDead, isNamespaceDefined, isXdmDocumentAttached, objEquals, objHashCode, qNameToString, removeAttribute, removeChild, removeChild, removeFromRelationship, removeToRelationship, removeXMLChild, resetElements, resetHash, resolve_equal2, resolveHRef, resolveHRef, s_equal2, s_equal2, s_equal2, setAttributes, setBase, setDocument, setDocumentAndReload, setElements, setId, setLang, setNamespaceContext, setNamespaces, setNode, setNodeName, setParent, setRegenerateNodeIfnotFound, setValue, setValue, setVariablesDefined, size, thin, toString, valueEquals, xEqual`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.ihr.xbrl.om.exLinks.XBRLAllowsDocumentation

      `getContainer`

    - ### Methods inherited from interface com.ihr.xbrl.om.XMLHasParent

      `addXMLChild, getBase, removeXMLChild, setParent`

- - ### Field Detail

    - #### lbType

          public static final javax.xml.namespace.QName lbType

      The Constant lbType.

    - #### lbResource

          public static final javax.xml.namespace.QName lbResource

      The Constant lbResource.

    - #### concept_label_arcrole_URI

          public static final java.lang.String concept_label_arcrole_URI

      The Constant concept_label_arcrole_URI.
      See Also:
        Constant Field Values

    - #### standard_arc

          public static final javax.xml.namespace.QName standard_arc

      The Constant standard_arc.

    - #### standard_role_ref

          public static final java.lang.String standard_role_ref

      The Constant standard_role_ref.
      See Also:
        Constant Field Values

    - #### label_role_URI

          public static final java.lang.String label_role_URI

      The Constant label_role_URI.
      See Also:
        Constant Field Values

    - #### terse_label_role_URI

          public static final java.lang.String terse_label_role_URI

      The Constant terse_label_role_URI.
      See Also:
        Constant Field Values

    - #### verbose_label_role_URI

          public static final java.lang.String verbose_label_role_URI

      The Constant verbose_label_role_URI.
      See Also:
        Constant Field Values

    - #### positive_label_role_URI

          public static final java.lang.String positive_label_role_URI

      The Constant positive_label_role_URI.
      See Also:
        Constant Field Values

    - #### positive_terse_label_role_URI

          public static final java.lang.String positive_terse_label_role_URI

      The Constant positive_terse_label_role_URI.
      See Also:
        Constant Field Values

    - #### positive_verbose_label_role_URI

          public static final java.lang.String positive_verbose_label_role_URI

      The Constant positive_verbose_label_role_URI.
      See Also:
        Constant Field Values

    - #### negative_label_role_URI

          public static final java.lang.String negative_label_role_URI

      The Constant negative_label_role_URI.
      See Also:
        Constant Field Values

    - #### negative_terse_label_role_URI

          public static final java.lang.String negative_terse_label_role_URI

      The Constant negative_terse_label_role_URI.
      See Also:
        Constant Field Values

    - #### negative_verbose_label_role_URI

          public static final java.lang.String negative_verbose_label_role_URI

      The Constant negative_verbose_label_role_URI.
      See Also:
        Constant Field Values

    - #### zero_label_role_URI

          public static final java.lang.String zero_label_role_URI

      The Constant zero_label_role_URI.
      See Also:
        Constant Field Values

    - #### zero_terse_label_role_URI

          public static final java.lang.String zero_terse_label_role_URI

      The Constant zero_terse_label_role_URI.
      See Also:
        Constant Field Values

    - #### zero_verbose_label_role_URI

          public static final java.lang.String zero_verbose_label_role_URI

      The Constant zero_verbose_label_role_URI.
      See Also:
        Constant Field Values

    - #### total_label_role_URI

          public static final java.lang.String total_label_role_URI

      The Constant total_label_role_URI.
      See Also:
        Constant Field Values

    - #### period_start_label_role_URI

          public static final java.lang.String period_start_label_role_URI

      The Constant period_start_label_role_URI.
      See Also:
        Constant Field Values

    - #### period_end_label_role_URI

          public static final java.lang.String period_end_label_role_URI

      The Constant period_end_label_role_URI.
      See Also:
        Constant Field Values

    - #### documentation_label_role_URI

          public static final java.lang.String documentation_label_role_URI

      The Constant documentation_label_role_URI.
      See Also:
        Constant Field Values

    - #### definition_guidance_label_role_URI

          public static final java.lang.String definition_guidance_label_role_URI

      The Constant definition_guidance_label_role_URI.
      See Also:
        Constant Field Values

    - #### disclosure_label_role_URI

          public static final java.lang.String disclosure_label_role_URI

      The Constant disclosure_label_role_URI.
      See Also:
        Constant Field Values

    - #### presentation_label_role_URI

          public static final java.lang.String presentation_label_role_URI

      The Constant presentation_label_role_URI.
      See Also:
        Constant Field Values

    - #### measurement_label_role_URI

          public static final java.lang.String measurement_label_role_URI

      The Constant measurement_label_role_URI.
      See Also:
        Constant Field Values

    - #### commentary_label_role_URI

          public static final java.lang.String commentary_label_role_URI

      The Constant commentary_label_role_URI.
      See Also:
        Constant Field Values

    - #### example_label_role_URI

          public static final java.lang.String example_label_role_URI

      The Constant example_label_role_URI.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### LabelLinkbase

          public LabelLinkbase(XBRLDocument parent,
                       net.sf.saxon.s9api.XdmNode node)

      Instantiates a new label linkbase.
      Parameters:
        `parent` - the parent
        `node` - the node

    - #### LabelLinkbase

          public LabelLinkbase(XBRLDocument parent,
                       DTSBase base)
                        throws XBRLInconsistentDTSException

      Deprecated. use `LabelLinkbase(XBRLDocument, XBRLRoleType)` instead
      Instantiates a new label linkbase.
      Parameters:
        `parent` - XBRLDocument
        `base` - DTSBase
      Throws:
        `XBRLInconsistentDTSException` - the XBRL inconsistent dts exception

    - #### LabelLinkbase

          public LabelLinkbase(XBRLDocument parent,
                       XBRLRoleType role)

      Creates a LabelLinkbase extended link container.
      Parameters:
        `parent` - the parent
        `role` - the role
      Since:
        2.6.5

  - ### Method Detail

    - #### readResources

          public void readResources()

      Description copied from class: `XBRLExtendedLink`
      Reads all resources in this linkbase This method uses XPath to identify the resources and try to obtain the resource object from the DTSContainer cache. This method then is able to identify orphaned resources

    - #### getLabelsForRole

          public java.util.Iterator<XBRLLabelResource> getLabelsForRole(XBRLRoleType role)
                                                                 throws XBRLValidationException

      Gets the labels for role.
      Parameters:
        `role` - the role
      Returns:
        the labels for role
      Throws:
        `XBRLValidationException` - the XBRL validation exception

    - #### getStaticLinkbaseType

          public javax.xml.namespace.QName getStaticLinkbaseType()

      Description copied from class: `XBRLExtendedLink`
      This function MUST be implemented by classes derived from this class.
      Specified by:
        `getStaticLinkbaseType` in class `XBRLExtendedLink`
      Returns:
        QName indicating the LinkbaseType like xbrli:footnoteLinkbase etc.

    - #### getExtendedLinkTypeName

          public java.lang.String getExtendedLinkTypeName()

      Description copied from class: `XBRLExtendedLink`
      Returns a localized constant string indicating the extended link type
      Specified by:
        `getExtendedLinkTypeName` in class `XBRLExtendedLink`
      Returns:
        String

    - #### isStandardExtendedLink

          public boolean isStandardExtendedLink()

      Description copied from class: `XBRLExtendedLink`
      Returns true if the extended link belongs to the XBRL 2.1 specification. This means it is a PresentationLinkbase, CalculationLinkbase, DefinitionLinkbase, LabelLinkbase, FootnoteLinkbase or ReferenceLinkbase
      Specified by:
        `isStandardExtendedLink` in class `XBRLExtendedLink`
      Returns:
        a boolean value that is true for XBRL 2.1 extended links only

    - #### getStandardResourceNodeNames

          public java.util.Collection<javax.xml.namespace.QName> getStandardResourceNodeNames()

      Description copied from class: `XBRLExtendedLink`
      Returns a collection of resource node names that are allowed to exist on this extended link.
      Specified by:
        `getStandardResourceNodeNames` in class `XBRLExtendedLink`
      Returns:
        collection of QNames, if no resources are allowed this is an empty collection of QNames

    - #### getStandardDefinedRolesOnResources

          public java.util.Collection<java.lang.String> getStandardDefinedRolesOnResources()

      Description copied from class: `XBRLExtendedLink`
      Returns a collection of role URIs that the XBRL 2.1 standard defines to be used on resources on this extended link
      Specified by:
        `getStandardDefinedRolesOnResources` in class `XBRLExtendedLink`
      Returns:
        collection of strings